include	clib.inc
include	ios.inc
include	unzip.inc
include	string.inc
include	errno.inc
include	math.inc
include	tdialog.inc

	.186

	public	unzip
	public	zip_attrib
if USE_CRYPT
	public	odecrypt
	extrn	password:	BYTE
	extrn	enterpassword:	BYTE
endif
	extrn	CP_WARNING: 	BYTE

_TEXT	SEGMENT

if USE_CRYPT

CRC32	PROC
	MOV	DX,BX
	XOR	AX,DX
	XOR	AH,AH
	ADD	AX,AX
	ADD	AX,AX
	MOV	BX,AX
	MOV	DL,DH
	MOV	DH,CL
	MOV	CL,CH
	MOV	CH,0
	MOV	AX,WORD PTR [BX+crctab]
	XOR	AX,DX
	MOV	DX,WORD PTR [BX+crctab+2]
	XOR	DX,CX
	ret
CRC32	ENDP

UPDATE_KEYS PROC
	mov	BX,WORD PTR PW_KEY0
	mov	CX,WORD PTR PW_KEY0+2
	push	AX
	call	CRC32
	mov	WORD PTR PW_KEY0,AX
	mov	WORD PTR PW_KEY0+2,DX
	MOV	DX,WORD PTR PW_KEY1+2
	MOV	AH,00h
	ADD	AX,WORD PTR PW_KEY1
	ADC	DX,0
	MOV	CX,0808h
	MOV	BX,8405h
	CALL	MUL32
	ADD	AX,1
	ADC	DX,0
	MOV	WORD PTR PW_KEY1,AX
	MOV	WORD PTR PW_KEY1+2,DX
	mov	BX,WORD PTR PW_KEY2
	mov	CX,WORD PTR PW_KEY2+2
	XOR	DX,DX
	MOV	AH,00h
	call	CRC32
	MOV	WORD PTR PW_KEY2,AX
	MOV	WORD PTR PW_KEY2+2,DX
	pop	AX
	ret
UPDATE_KEYS ENDP

DECRYPTBYTE PROC
	mov	BX,WORD PTR PW_KEY2
	or	BX,2
	mov	DX,BX
	xor	DX,1
	mov	AX,BX
	mul	DX
	MOV	AL,AH
	ret
DECRYPTBYTE ENDP

INIT_KEYS PROC
	mov	WORD PTR PW_KEY0,5678h
	mov	WORD PTR PW_KEY0+2,1234h
	mov	WORD PTR PW_KEY1,6789h
	mov	WORD PTR PW_KEY1+2,2345h
	mov	WORD PTR PW_KEY2,7890h
	mov	WORD PTR PW_KEY2+2,3456h
	push	SI
	mov	SI,OFFSET password
IKEYS_00:
	xor	AX,AX
	mov	AL,[SI]
	inc	SI
	or	AL,AL
	jz	IKEYS_01
	call	UPDATE_KEYS
	jmp	IKEYS_00
IKEYS_01:
	pop	SI
	ret
INIT_KEYS ENDP

odecrypt PROC
	push	SI
	xor	SI,SI
ODECR_00:
	call	DECRYPTBYTE
	les	BX,STDI.ios_bp
	add	BX,SI
	xor	ES:[BX],AL
	mov	AL,ES:[BX]
	call	UPDATE_KEYS
	inc	SI
	cmp	SI,STDI.ios_c
	jl	ODECR_00
	pop	SI
	ret
odecrypt ENDP

TESTPW	PROC
	push	BP
	sub	SP,12
	mov	BP,SP
	push	SI
	call	INIT_KEYS
	push	SS
	push	BP
	PUSH32	[BP+4+12]
	push	12
	call	memcpy
	xor	SI,SI
TESTPW_00:
	call	DECRYPTBYTE
	xor	SS:[BP+SI],AL
	mov	AL,[BP+SI]
	call	UPDATE_KEYS
	inc	SI
	cmp	SI,12
	jl	TESTPW_00
	mov	AX,zip_attrib
	and	AX,_A_EXTLOCHD
	mov	AX,zip_local.lz_time
	jnz	TESTPW_01
	mov	AX,WORD PTR zip_local.lz_crc+2
TESTPW_01:
	cmp	AH,[BP+11]
	je	TESTPW_02
	mov	AX,-1
	jmp	TESTPW_04
TESTPW_02:
	mov	CX,STDI.ios_c
	sub	CX,12
	les	SI,STDI.ios_bp
	add	SI,12
TESTPW_03:
	call	DECRYPTBYTE
	xor	ES:[SI],AL
	mov	AL,ES:[SI]
	call	UPDATE_KEYS
	inc	SI
	dec	CX
	jnz	TESTPW_03
	xor	AX,AX
TESTPW_04:
	pop	SI
	add	SP,12
	pop	BP
	ret	4
TESTPW	ENDP

ZIPDECRYPT PROC
	push	BP
	sub	SP,12
	mov	BP,SP
	push	SI
	push	DI
	mov	SI,12
	mov	DI,BP
DCRYPT_00:
	call	ogetc
	mov	SS:[DI],AL
	inc	DI
	dec	SI
	jnz	DCRYPT_00
	push	SS
	push	BP
	call	TESTPW
	or	AX,AX
	jz	DCRYPT_02
	mov	password,0
	push	DS
	push	OFFSET enterpassword
	push	DS
	push	OFFSET password
	PUSH	32
	PUSH	80
	call	tgetline
	or	AX,AX
	jz	DCRYPT_01
	xor	AX,AX
	cmp	password,AL
	jz	DCRYPT_01
	push	SS
	push	BP
	call	TESTPW
	or	AX,AX
	jz	DCRYPT_02
	xor	AX,AX
DCRYPT_01:
	pop	DI
	pop	SI
	add	SP,12
	pop	BP
	ret
DCRYPT_02:
	mov	AX,1
	jmp	DCRYPT_01
ZIPDECRYPT ENDP

endif ; USE_CRYPT

ZIPFREE	PROC
	mov	AX,OSTDI
	call	ofreest
	mov	AX,OSTDO
	call	ofreest
	mov	AX,ER_MEM
	ret
ZIPFREE	ENDP

ZIPALLOC PROC
	mov	STDI.ios_file,AX
	mov	STDO.ios_file,DX
	mov	AX,OSTDI
	call	oinitst
	jz	ZALLOC_01
	mov	AX,OSTDO
	call	oinitst
	JNZ	ZALLOC_03
	JMP	ZIPFREE
ZALLOC_03:
	mov	STDI.ios_flag,IO_USEBITS
	mov	STDO.ios_flag,IO_UPDTOTAL or IO_USEUPD or IO_USECRC
	xor	AX,AX
	test	zip_attrib,_A_ENCRYPTED
if USE_CRYPT
	jz	ZALLOC_00
	call	ogetc
	jz	ZALLOC_02
	dec	STDI.ios_i
	call	ZIPDECRYPT
	or	AX,AX
	jz	ZALLOC_02
	or	STDI.ios_flag,IO_CRYPT
	xor	AX,AX
else
	jnz	ZALLOC_02
endif
ZALLOC_00:
	ret
ZALLOC_01:
	mov	AX,ER_MEM
	ret
ZALLOC_02:
	call	ZIPFREE
	mov	AX,-1
	ret
ZIPALLOC ENDP

unzip	PROC	DIST
	push	SI
	call	ZIPALLOC
	mov	SI,AX
	or	AX,AX
	jnz	unzip_05
	mov	AX,zip_local.lz_method
	or	AX,AX
	jz	unzip_01
	cmp	AX,8
	je	unzip_03
	cmp	AX,6
	je	unzip_04
unzip_00:
	push	zip_local.lz_method
	PUSH32	[sys_errlist+(ENOSYS*DPTRZ)]
	mov	DX,OFFSET format_sL_02X
	mov	AX,OFFSET CP_WARNING
	call	@ermsgt
	add	SP,6
	mov	SI,3
	jmp	unzip_05
unzip_01:
	mov	STDI.ios_flag,IO_USECRC
	PUSH32	zip_local.lz_fsize
	xor	SI,SI
	call	ocopy
	jnz	unzip_05
	mov	SI,AX
	jmp	unzip_05
unzip_02:
	cmp	errno,ENOMEM
	jne	unzip_05
	mov	SI,ER_MEM
	jmp	unzip_05
unzip_03:
	call	zip_inflate
	mov	SI,AX
	jmp	unzip_05
unzip_04:
	call	zip_explode
	mov	SI,AX
unzip_05:
	call	ZIPFREE
	test	STDO.ios_flag,IO_ERROR
	jnz	unzip_07
	or	SI,SI
	jnz	unzip_06
	mov	AX,WORD PTR STDO.ios_bb+2
	not	AX
	cmp	AX,WORD PTR zip_local.lz_crc+2
	JNE	UNZIP_08
	mov	AX,WORD PTR STDO.ios_bb
	not	AX
	cmp	AX,WORD PTR zip_local.lz_crc
	je	unzip_06
UNZIP_08:
	mov	SI,ER_CRCERR
unzip_06:
	mov	AX,SI
	pop	SI
	ret
unzip_07:
	mov	SI,ER_DISK
	jmp	unzip_06
unzip	ENDP

_TEXT	ENDS

_DATA	SEGMENT

zip_attrib	DW	?
if USE_CRYPT
PW_KEY0		DD	?
PW_KEY1		DD	?
PW_KEY2		DD	?
endif
format_sL_02X	DB	"%s",10,"'%02X'",0

_DATA	ENDS

	END
